import re
from django.core.exceptions import ValidationError
from django import forms
from django.shortcuts import render
from django.http import HttpResponse
from warpauth.ldap_connector import LDAPConnector
from warpauth.models import LdapUser
from warpauth.util import *

def register(request):
    pages['success'] = False
    pages['error'] = False

    if request.method == "POST":
        username = request.POST['username']
        password = request.POST['password']
        password2 = request.POST['password2']
        email = request.POST['email']
        f = forms.EmailField()
        try:
            f.clean(email)
        except ValidationError as e:
            pages["error"] = "invalid_email"

        if username == "" or email == "" or password == "" or password2 == "":
            pages['error'] = "fill_all_fields"
        elif not re.search(r'^\w+$', username):
            pages['error'] = "invalid_username"
        elif password != password2:
            pages['error'] = "passwords_did_not_match"
        elif not pages["error"]:
            u = LdapUser.objects.filter(uid=username)
            if u.count() == 0:
                user = LdapUser()
                user.uid = username
                user.first_name = "None"
                user.last_name = "None"
                user.cn = username
                user.email = email
                user.uidNumber = "513"
                user.gidNumber = "100"
                user.homeDirectory = "/dev/null"
                user.save()
                ldap_connector = LDAPConnector()
                ldap_connector.change_user_password(user.build_dn(), None, request.POST["password"], True)
                pages['success'] = True
            else:
                pages['error'] = "username_not_available"

    return HttpResponse(render(request, 'warpauth/register.html', pages))
